Loading...
Searching...
No Matches
file_source.h
Go to the documentation of this file.
/* -*- c++ -*- */
/*
* Copyright 2012, 2018 Free Software Foundation, Inc.
*
* This file is part of GNU Radio
*
* SPDX-License-Identifier: GPL-3.0-or-later
*
*/
#ifndef INCLUDED_BLOCKS_FILE_SOURCE_H
#define INCLUDED_BLOCKS_FILE_SOURCE_H
#include <gnuradio/blocks/api.h>
#include <gnuradio/sync_block.h>
namespace gr {
namespace blocks {
/*!
* \brief Read stream from file
* \ingroup file_operators_blk
*/
class BLOCKS_API file_source : virtual public sync_block
{
public:
// gr::blocks::file_source::sptr
typedef std::shared_ptr<file_source> sptr;
/*!
* \brief Create a file source.
*
* Opens \p filename as a source of items into a flowgraph. The
* data is expected to be in binary format, item after item. The
* \p itemsize of the block determines the conversion from bits
* to items. The first \p offset items (default 0) will be
* skipped.
*
* If \p repeat is turned on, the file will repeat the file after
* it's reached the end.
*
* If \p len is non-zero, only items (offset, offset+len) will
* be produced.
*
* \param itemsize the size of each item in the file, in bytes
* \param filename name of the file to source from
* \param repeat repeat file from start
* \param offset begin this many items into file
* \param len produce only items (offset, offset+len)
*/
static sptr make(size_t itemsize,
const char* filename,
bool repeat = false,
uint64_t offset = 0,
uint64_t len = 0);
/*!
* \brief seek file to \p seek_point relative to \p whence
*
* \param seek_point sample offset in file
* \param whence one of SEEK_SET, SEEK_CUR, SEEK_END (man fseek)
*/
virtual bool seek(int64_t seek_point, int whence) = 0;
/*!
* \brief Opens a new file.
*
* \param filename name of the file to source from
* \param repeat repeat file from start
* \param offset begin this many items into file
* \param len produce only items [offset, offset+len)
*/
virtual void
open(const char* filename, bool repeat, uint64_t offset = 0, uint64_t len = 0) = 0;
/*!
* \brief Close the file handle.
*/
virtual void close() = 0;
/*!
* \brief Add a stream tag to the first sample of the file if true
*/
virtual void set_begin_tag(pmt::pmt_t val) = 0;
};
} /* namespace blocks */
} /* namespace gr */
#endif /* INCLUDED_BLOCKS_FILE_SOURCE_H */
gr::blocks::file_source
Read stream from file.
Definition file_source.h:25
gr::blocks::file_source::seek
virtual bool seek(int64_t seek_point, int whence)=0
seek file to seek_point relative to whence
gr::blocks::file_source::close
virtual void close()=0
Close the file handle.
gr::blocks::file_source::open
virtual void open(const char *filename, bool repeat, uint64_t offset=0, uint64_t len=0)=0
Opens a new file.
gr::blocks::file_source::make
static sptr make(size_t itemsize, const char *filename, bool repeat=false, uint64_t offset=0, uint64_t len=0)
Create a file source.
gr::blocks::file_source::sptr
std::shared_ptr< file_source > sptr
Definition file_source.h:28
gr::blocks::file_source::set_begin_tag
virtual void set_begin_tag(pmt::pmt_t val)=0
Add a stream tag to the first sample of the file if true.
gr::blocks::repeat
repeat each input repeat times
Definition repeat.h:30
gr::sync_block
synchronous 1:1 input to output with history
Definition sync_block.h:26
api.h
BLOCKS_API
#define BLOCKS_API
Definition gr-blocks/include/gnuradio/blocks/api.h:18
gr
GNU Radio logging wrapper.
Definition basic_block.h:29
pmt::pmt_t
std::shared_ptr< pmt_base > pmt_t
typedef for shared pointer (transparent reference counting).
Definition pmt.h:83
sync_block.h